From 9ea5d44cb0a4a00fdb78979c5a63f3e3bfb3240f Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Sun, 8 Jan 2023 15:07:58 +0100
Subject: [PATCH] manager: redo <title> to be "page name | global name"
 (#73382)

---
 .../authentic2/authenticators/authenticator_common.html       | 2 +-
 .../templates/authentic2/manager/api_client_common.html       | 2 +-
 src/authentic2/manager/templates/authentic2/manager/base.html | 2 +-
 .../manager/templates/authentic2/manager/import_form.html     | 2 +-
 .../manager/templates/authentic2/manager/journal.html         | 2 +-
 .../manager/templates/authentic2/manager/ou_detail.html       | 4 +---
 src/authentic2/manager/templates/authentic2/manager/ous.html  | 2 +-
 .../manager/templates/authentic2/manager/role_common.html     | 2 +-
 .../manager/templates/authentic2/manager/role_edit.html       | 2 +-
 .../templates/authentic2/manager/role_permissions.html        | 2 +-
 .../manager/templates/authentic2/manager/roles.html           | 2 +-
 .../manager/templates/authentic2/manager/service.html         | 2 +-
 .../manager/templates/authentic2/manager/services.html        | 2 +-
 .../manager/templates/authentic2/manager/user_add.html        | 4 +---
 .../templates/authentic2/manager/user_authorizations.html     | 2 +-
 .../templates/authentic2/manager/user_common_roles.html       | 2 +-
 .../manager/templates/authentic2/manager/user_detail.html     | 2 +-
 .../manager/templates/authentic2/manager/user_edit.html       | 2 +-
 .../manager/templates/authentic2/manager/user_export.html     | 2 +-
 .../manager/templates/authentic2/manager/user_import.html     | 2 +-
 .../templates/authentic2/manager/user_import_report.html      | 2 +-
 .../manager/templates/authentic2/manager/user_imports.html    | 2 +-
 .../manager/templates/authentic2/manager/users.html           | 2 +-
 23 files changed, 23 insertions(+), 27 deletions(-)

diff --git a/src/authentic2/apps/authenticators/templates/authentic2/authenticators/authenticator_common.html b/src/authentic2/apps/authenticators/templates/authentic2/authenticators/authenticator_common.html
index b05883c91..1b1538437 100644
--- a/src/authentic2/apps/authenticators/templates/authentic2/authenticators/authenticator_common.html
+++ b/src/authentic2/apps/authenticators/templates/authentic2/authenticators/authenticator_common.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n %}
 
-{% block page-title %}{{ block.super }} - {% if object %}{{ object }}{% else %}{% trans "Authenticators" %}{% endif %}{% endblock %}
+{% block page-title %}{% if object %}{{ object }}{% else %}{% trans "Authenticators" %}{% endif %} | {{ block.super }}{% endblock %}
 
 {% block title %}{{ block.super }} - {% trans "Authenticators" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/api_client_common.html b/src/authentic2/manager/templates/authentic2/manager/api_client_common.html
index 0701a79bd..36bb0d399 100644
--- a/src/authentic2/manager/templates/authentic2/manager/api_client_common.html
+++ b/src/authentic2/manager/templates/authentic2/manager/api_client_common.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n %}
 
-{% block page-title %}{{ block.super }} - {% if object %}{{ object }}{% else %}{% trans "API Clients" %}{% endif %}{% endblock %}
+{% block page-title %}{% if object %}{{ object }}{% else %}{% trans "API Clients" %}{% endif %} | {{ block.super }}{% endblock %}
 
 {% block title %}{{ block.super }} - {% trans "API Clients" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/base.html b/src/authentic2/manager/templates/authentic2/manager/base.html
index 4899b4b9d..799e6ca7a 100644
--- a/src/authentic2/manager/templates/authentic2/manager/base.html
+++ b/src/authentic2/manager/templates/authentic2/manager/base.html
@@ -4,7 +4,7 @@
 {% block gadjo-js %}{% endblock %}
 {% block bodyargs %} class="{% block bodyclasses %}{% endblock %}"{% endblock %}
 
-{% block page-title %}{% firstof manager_site_title site_title "Authentic2" %}{% endblock %}
+{% block page-title %}{% firstof global_title manager_site_title site_title "Authentic2" %}{% endblock %}
 {% block site-title %}{% firstof manager_site_title site_title "Authentic2" %}{% endblock %}
 
 {% block logout-url %}{% url 'auth_logout' %}?next={{ request.get_full_path|urlencode }}{% endblock %}
diff --git a/src/authentic2/manager/templates/authentic2/manager/import_form.html b/src/authentic2/manager/templates/authentic2/manager/import_form.html
index d14a2c2ed..d86027514 100644
--- a/src/authentic2/manager/templates/authentic2/manager/import_form.html
+++ b/src/authentic2/manager/templates/authentic2/manager/import_form.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/form.html" %}
 {% load gadjo i18n %}
 
-{% block page-title %}{{ title }}{% endblock %}
+{% block page-title %}{{ title }} | {{ block.super }}{% endblock %}
 
 {% block appbar %}
   <h2>{{ title }}</h2>
diff --git a/src/authentic2/manager/templates/authentic2/manager/journal.html b/src/authentic2/manager/templates/authentic2/manager/journal.html
index 4d4967be5..b38f91cec 100644
--- a/src/authentic2/manager/templates/authentic2/manager/journal.html
+++ b/src/authentic2/manager/templates/authentic2/manager/journal.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n gadjo %}
 
-{% block page-title %}{{ block.super }}{% if object_name %} - {{ object_name }}{% endif %} - {% trans "Journal" %}{% endblock %}
+{% block page-title %}{% trans "Journal" %}{% if object_name %} - {{ object_name }}{% endif %} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/ou_detail.html b/src/authentic2/manager/templates/authentic2/manager/ou_detail.html
index 3522dca9a..648868975 100644
--- a/src/authentic2/manager/templates/authentic2/manager/ou_detail.html
+++ b/src/authentic2/manager/templates/authentic2/manager/ou_detail.html
@@ -1,9 +1,7 @@
 {% extends "authentic2/manager/form.html" %}
 {% load i18n %}
 
-{% block page-title %}
-  {{ block.super }} - {% trans "Organizational unit" %} - {{ object }}
-{% endblock %}
+{% block page-title %}{% trans "Organizational unit" %} - {{ object }} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/ous.html b/src/authentic2/manager/templates/authentic2/manager/ous.html
index 6979184c3..656265a2a 100644
--- a/src/authentic2/manager/templates/authentic2/manager/ous.html
+++ b/src/authentic2/manager/templates/authentic2/manager/ous.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/ou_common.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{{ block.super }} - {% trans "Organizational units" %}{% endblock %}
+{% block page-title %}{% trans "Organizational units" %} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_common.html b/src/authentic2/manager/templates/authentic2/manager/role_common.html
index c6c02ae1f..8c000860b 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_common.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_common.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n static %}
 
-{% block page-title %}{{ block.super }}{% if object %} - {{ object }}{% endif %}{% endblock %}
+{% block page-title %}{% if object %}{{ object }} | {% endif %}{{ block.super }}{% endblock %}
 
 {% block title %}{{ block.super }} - {% trans "Roles" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_edit.html b/src/authentic2/manager/templates/authentic2/manager/role_edit.html
index 8201a1856..5918c9a64 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_edit.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_edit.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/role_common.html" %}
 {% load i18n gadjo %}
 
-{% block page-title %}{{ block.super }} - {% trans "Edit" %}{% endblock %}
+{% block page-title %}{% trans "Edit" %} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_permissions.html b/src/authentic2/manager/templates/authentic2/manager/role_permissions.html
index 2215175dd..ccc3e9d36 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_permissions.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_permissions.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/role_common.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{{ block.super }} - {% trans "Permissions" %}{% endblock %}
+{% block page-title %}{% trans "Permissions" %} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/roles.html b/src/authentic2/manager/templates/authentic2/manager/roles.html
index e4e7724da..827ae7bd1 100644
--- a/src/authentic2/manager/templates/authentic2/manager/roles.html
+++ b/src/authentic2/manager/templates/authentic2/manager/roles.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/role_common.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{{ block.super }} - {% trans "Roles" %}{% endblock %}
+{% block page-title %}{% trans "Roles" %} | {{ block.super }}{% endblock %}
 
 {% block page_title %}{% if multiple_ou and ou %}{{ ou }}{% else %}{{ block.super }}{% endif %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/service.html b/src/authentic2/manager/templates/authentic2/manager/service.html
index 0a1599a9c..f637819c5 100644
--- a/src/authentic2/manager/templates/authentic2/manager/service.html
+++ b/src/authentic2/manager/templates/authentic2/manager/service.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{% firstof manager_site_title site_title "Authentic2" %} - {{ object }}{% endblock %}
+{% block page-title %}{{ object }} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/services.html b/src/authentic2/manager/templates/authentic2/manager/services.html
index 13124e4fe..39a83c48a 100644
--- a/src/authentic2/manager/templates/authentic2/manager/services.html
+++ b/src/authentic2/manager/templates/authentic2/manager/services.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{{ block.super }} - {% trans "Services" %}{% endblock %}
+{% block page-title %}{% trans "Services" %} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_add.html b/src/authentic2/manager/templates/authentic2/manager/user_add.html
index 450bffc48..8a21f796c 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_add.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_add.html
@@ -1,9 +1,7 @@
 {% extends "authentic2/manager/form.html" %}
 {% load i18n %}
 
-{% block page-title %}
-  {% trans "Add an user" %}
-{% endblock %}
+{% block page-title %}{% trans "Add an user" %} | {{ block.super }}{% endblock %}
 
 {% block beforeform %}
   {% if duplicate_users %}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html b/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html
index 8e588079f..cc63ec107 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{{ block.super }} - {% trans "Users" %}{% endblock %}
+{% block page-title %}{% trans "Users" %} | {{ block.super }}{% endblock %}
 
 {% block appbar %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_common_roles.html b/src/authentic2/manager/templates/authentic2/manager/user_common_roles.html
index 80d520700..def19b614 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_common_roles.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_common_roles.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n %}
 
-{% block page-title %}{{ block.super }} - {{ object }} - {% trans "Edit roles" %}{% endblock %}
+{% block page-title %}{% trans "Edit roles" %} - {{ object }} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_detail.html b/src/authentic2/manager/templates/authentic2/manager/user_detail.html
index 99c261df0..b3abbfe04 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_detail.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_detail.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/form.html" %}
 {% load i18n static %}
 
-{% block page-title %}{{ block.super }} - {{ object }}{% endblock %}
+{% block page-title %}{{ object }} | {{ block.super }}{% endblock %}
 
 {% block appbar %}
   <h2>{{ object }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_edit.html b/src/authentic2/manager/templates/authentic2/manager/user_edit.html
index 2daec4cf5..80b4fba27 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_edit.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_edit.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/form.html" %}
 {% load i18n %}
 
-{% block page-title %}{{ block.super }} - {{ object }} - {% trans "Edit" %}{% endblock %}
+{% block page-title %}{% trans "Edit" %} - {{ object }} | {{ block.super }}{% endblock %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_export.html b/src/authentic2/manager/templates/authentic2/manager/user_export.html
index f8103520d..70cca3d32 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_export.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_export.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n gadjo static %}
 
-{% block page-title %}{{ block.super }} - {% trans "User export" %}{% endblock %}
+{% block page-title %}{% trans "User export" %} | {{ block.super }}{% endblock %}
 
 {% block appbar %}
   <h2>Users export</h2>
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_import.html b/src/authentic2/manager/templates/authentic2/manager/user_import.html
index 6eb58a19a..4d4440fb3 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_import.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_import.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n gadjo static %}
 
-{% block page-title %}{{ block.super }} - {% trans "Import Users" %}{% endblock %}
+{% block page-title %}{% trans "Import Users" %} | {{ block.super }}{% endblock %}
 
 {% block css %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_import_report.html b/src/authentic2/manager/templates/authentic2/manager/user_import_report.html
index ead02cb32..042b0034c 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_import_report.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_import_report.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n gadjo static %}
 
-{% block page-title %}{{ block.super }} - {% trans "Import Users" %}{% endblock %}
+{% block page-title %}{% trans "Import Users" %} | {{ block.super }}{% endblock %}
 
 {% block css %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_imports.html b/src/authentic2/manager/templates/authentic2/manager/user_imports.html
index c464a5c89..08059c58e 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_imports.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_imports.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n gadjo static %}
 
-{% block page-title %}{{ block.super }} - {% trans "Import Users" %}{% endblock %}
+{% block page-title %}{% trans "Import Users" %} | {{ block.super }}{% endblock %}
 
 {% block page_title %}{% trans "Imports" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/users.html b/src/authentic2/manager/templates/authentic2/manager/users.html
index d104308a1..f844fc6c0 100644
--- a/src/authentic2/manager/templates/authentic2/manager/users.html
+++ b/src/authentic2/manager/templates/authentic2/manager/users.html
@@ -1,7 +1,7 @@
 {% extends "authentic2/manager/base.html" %}
 {% load i18n static django_tables2 %}
 
-{% block page-title %}{{ block.super }} - {% trans "Users" %}{% endblock %}
+{% block page-title %}{% trans "Users" %} | {{ block.super }}{% endblock %}
 
 {% block appbar %}
   {{ block.super }}
-- 
2.39.0